//-------------------------------------------------------------------------------------------------
// DebugDrawElement.hpp (engine)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#ifndef _include_DebugDrawElement_
#define _include_DebugDrawElement_


//-------------------------------------------------------------------------------------------------
// Included header files
//-------------------------------------------------------------------------------------------------
#include "engineCommon.hpp"
#include "Rgba.hpp"
#include "Vector2.hpp"
//#include "AABB2.hpp"
//#include "LineSegment2.hpp"
//#include "Image.hpp"
//#include "Texture.hpp"


///////////////////////////////////////////////////////////////////////////////////////////////////
//
//		DebugDrawElement
//
///////////////////////////////////////////////////////////////////////////////////////////////////
class DebugDrawElement
{
protected:
	static std::list<DebugDrawElement> s_debugDrawList;
	static void DebugDrawElement::DrawDebugElements();

public:
	DebugDrawElement();
	virtual ~DebugDrawElement();
};


///////////////////////////////////////////////////////////////////////////////////////////////////
//
//		DebugDrawVector
//
///////////////////////////////////////////////////////////////////////////////////////////////////
class DebugDrawVector : public DebugDrawElement
{
	Vector2		_start;
	Vector2		_end;
	Rgba		_startColor;
	Rgba		_endColor;

public:
	DebugDrawVector( const Vector2& start, const Vector2& end, const Rgba& startColor, const Rgba& endColor );
};


/*
	//-------------------------------------------------------------------------------------------------
	// DebugDrawType
	//-------------------------------------------------------------------------------------------------
	enum DebugDrawType
	{
		DEBUG_DRAW_POINT,
		DEBUG_DRAW_CIRCLE,
		DEBUG_DRAW_VECTOR,
		DEBUG_DRAW_AABB2,
	};

*/



#endif // _include_TheDebugDrawElement_
