//-------------------------------------------------------------------------------------------------
// TheGameInterfaceAbstract.hpp (engine)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
// 
// Header file for TheGameInterfaceAbstract singleton base class.
//-------------------------------------------------------------------------------------------------
#ifndef _include_TheGameInterfaceAbstract_
#define _include_TheGameInterfaceAbstract_


//-------------------------------------------------------------------------------------------------
// Included header files
//-------------------------------------------------------------------------------------------------
#include "engineCommon.hpp"
#include "TheInputSystem.hpp"


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//		TheGameInterfaceAbstract
// 
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
class TheGameInterfaceAbstract
{
private:
	static TheGameInterfaceAbstract* _theGameInterfaceAbstract;
	static bool _isConstructed;

	//---------------------------------------------------------------------------
	// Begin public class interface
	//---------------------------------------------------------------------------
public:
	static TheGameInterfaceAbstract* Singleton();
	static bool IsGamePresent() { return _isConstructed; }

	TheGameInterfaceAbstract(); // default constructor
	virtual ~TheGameInterfaceAbstract(); // destructor

	/// Virtual methods that may be implemented by the derived game class
	virtual void PreInit();
	virtual void PostInit();
	virtual void RunFrame();
	virtual void Shutdown();
	virtual void ProcessCommandLine( std::string cmdLine );
	virtual const bool ProcessInputEvent( const TheInputSystem::inputEventType_e eventType, const byte_t key );
};
	//---------------------------------------------------------------------------
	// End public class interface
	//---------------------------------------------------------------------------



#endif // _include_TheGameInterfaceAbstract_
